#ifndef INSTANCE_H
#define INSTANCE_H

#include <bits/stdc++.h>


class pos {
  public:
    pos(int x, int y);
    int dist2(pos &b);
    int x, y;
};

class warehouse {
  public:
    warehouse(pos p, std::vector<int> disp);
    pos p;
    std::vector<int> disp;
};

class order {
  public:
    order(pos p, std::map<int, int> ord);
    pos p;
    std::map<int, int> ord;
};

class instance {
  public:
    instance(); // read from stdin
    int find(pos p, int id); // cherche une warehouse proche de x/y
    int row, col, drones, max_load;
    int T; // deadline
    int P; // # products
    int W; // # warehouses
    int C; // # orders
    std::vector<int> weights;
    std::vector<warehouse> wh;
    std::vector<order> orders;
};

#endif
